package {

	import Effects;

	public class Script {

		private var queue:Array = new Array();
		private var current:Array = new Array();
		private var script:Object = new Object();
		private var parent:Field = null;
		public var fx:Effects = new Effects();

		private var timenudge = 20; // Woohooo, FLASH FTW \o/

		public function update( time:Number ) {
			// shift actions due from the queue to current actions
			for( var i=0; i< this.queue.length; i++ ) {
				var q = this.queue[i];
				if( q.start < time + this.timenudge ) {
					if( q.z == undefined ) { q.z = 100; }
					q.z += q.start/200000; // Keep chronological order!
					
					this.current.push( q );
					this.current.sortOn( 'z', Array.NUMERIC );
					this.queue.shift();
					i--;
				} else if( q.start > time ) {
					break;
				}
			}

			// update all current actions
			for( i=0; i< this.current.length; i++ ) {
				var c = this.current[i];
				if( c.end < time ) {
					// time's up - update the action once again, then remove it
					c.func( this.parent, time, 1);
					this.current.splice( i, 1 );
					i--;
				} else {
					c.func( this.parent, time, Math.max(0, (time - c.start)/(c.end - c.start)) );
				}
			}
		}

		
		public function Script( parent:Field ) {
			this.parent = parent;
			parent.cache.all = parent.base.all();

// Actions definition (Selections + Effects) ////////////////////////////////////////////////////////////////
			
	// Strings intro sequence ---------------------------------------------------------------------------
			this.script.rowCenterShort = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.48, 0.5, 0.52, 0.5 ).each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.circleCenterSmall = function( parent:Field, time:Number, age:Number ) {
				parent.base.circle( 0.5, 0.5, 0.02 ).each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.pointCenter = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.5, 0.5, 0.5, 0.5 ).each( parent.fx.scale, { value: 2-age*2 }, time );
			}

			this.script.rectCenterSmall = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.46, 0.47, 0.54, 0.53 ).each( parent.fx.scale, { value: (1-age)*0.7 }, time );
			}

			this.script.squareCenterSmall = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.47, 0.47, 0.53, 0.53 ).each( parent.fx.scale, { value: (1-age)*0.7 }, time );
			}

			this.script.columnLeftShort = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.45, 0.47, 0.45, 0.53 ).each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.columnCenterShort = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.5, 0.47, 0.5, 0.53 ).each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.columnRightShort = function( parent:Field, time:Number, age:Number ) {
				parent.base.rect( 0.55, 0.47, 0.55, 0.53 ).each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.circleCenterMedium = function( parent:Field, time:Number, age:Number ) {
				parent.base.circle( 0.5, 0.5, 0.1 ).each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.circleCenterMediumFilled = function( parent:Field, time:Number, age:Number ) {
				parent.base.circle( 0.5, 0.5, 0.08 ).fill( 0.5, 0.5).each( parent.fx.scale, { value: 1-age }, time );
			}


	// Strings chorus sequence ------------------------------------------------------------------------------
			parent.cache.stringSequence01 = parent.base.rect( 0, 0.34, 0.2, 0.65 ).fill( 0.1, 0.5);
			parent.cache.stringSequence02 = parent.base.rect( 0.2, 0.34, 0.4, 0.65 ).fill( 0.3, 0.5);
			parent.cache.stringSequence03 = parent.base.rect( 0.4, 0.34, 0.6, 0.65 ).fill( 0.5, 0.5);
			parent.cache.stringSequence04 = parent.base.rect( 0.6, 0.34, 0.8, 0.65 ).fill( 0.7, 0.5);
			parent.cache.stringSequence05 = parent.base.rect( 0.8, 0.34, 1, 0.65 ).fill( 0.9, 0.5);

			this.script.stringSequence01 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.stringSequence01
					.each( parent.fx.plasma, {}, time/1000 )
					.each( parent.fx.scale, { factor: (1-age)*3 }, time );
			}

			this.script.stringSequence02 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.stringSequence02
					.each( parent.fx.plasma, {}, time/1000 )
					.each( parent.fx.scale, { factor: (1-age)*3 }, time );
			}

			this.script.stringSequence03 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.stringSequence03
					.each( parent.fx.plasma, {}, time/1000 )
					.each( parent.fx.scale, { factor: (1-age)*3 }, time );
			}
			this.script.stringSequence04 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.stringSequence04
					.each( parent.fx.plasma, {}, time/1000 )
					.each( parent.fx.scale, { factor: (1-age)*3 }, time );
			}
			this.script.stringSequence05 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.stringSequence05
					.each( parent.fx.plasma, {}, time/1000 )
					.each( parent.fx.scale, { factor: (1-age)*3 }, time );
			}



	// Strings rect center ----------------------------------------------------------------------------------
			parent.cache.rectCenterPlasma = parent.base.rect( 0, 0.4, 1, 0.52 );
			parent.cache.rectCenterPlasmaCondensed = parent.base.rect( 0, 0.55, 1, 0.6 ).fill( 0.5, 0.575 )

			this.script.rectCenterPlasma = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectCenterPlasma
					.fill( 0.5, 0.5 )
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectCenterPlasmaCondensed = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectCenterPlasmaCondensed
					.each( parent.fx.scale, { value: 1-age }, time );
			}


	// Strings rect grow horz -------------------------------------------------------------------------------
			this.script.rectLeftToRight = function( parent:Field, time:Number, age:Number ) {
				parent.base
					.rect( 0, 0.4, Math.min(age*2,1), 0.6 )
					.fill( age, 0.5 )
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectRightToLeft = function( parent:Field, time:Number, age:Number ) {
				parent.base
					.rect( 1-Math.min(age*2,1), 0.4, 1, 0.6 )
					.fill( 1-age, 0.5 )
					.each( parent.fx.scale, { value: 1-age }, time );
			}



	// Strings center circle grow ---------------------------------------------------------------------------
			parent.cache.circleCenterClear = parent.base
				.circle( 0.5, 0.5, 0.2 ).fill( 0.5, 0.5 );

			parent.cache.circleCenterHollow = parent.base
				.circle( 0.5, 0.5, 0.2 );

			this.script.circleCenterContract = function( parent:Field, time:Number, age:Number ) {
				parent.cache.circleCenterClear
					.each( parent.fx.scale, { value: 0 }, time );
				parent.base
					.circle( 0.5, 0.5, Math.max(0.2 - age*0.5, 0) ).fill( 0.5, 0.5, 0.5)
						.each( parent.fx.scale, { value: (1-age) }, time );
			}
			
			this.script.circleCenterExpand = function( parent:Field, time:Number, age:Number ) {
				parent.base
					.circle( 0.5, 0.5, Math.min(age*0.5, 0.2) ).fill( 0.5, 0.5, 0.5)
						.each( parent.fx.scale, { value: (1-age) }, time );
			}

			this.script.circleCenterHollow = function( parent:Field, time:Number, age:Number ) {
				parent.cache.circleCenterHollow
					.each( parent.fx.scale, { value: Math.max( 2-age*4, 0) }, time );
			}



	// Strings Build Rect -----------------------------------------------------------------------------------
			parent.cache.rectEdgesLeft = parent.base.rect( 0.4, 0.4, 0.4, 0.6 );
			parent.cache.rectEdgesRight = parent.base.rect( 0.6, 0.4, 0.6, 0.6 );
			parent.cache.rectEdgesTop = parent.base.rect( 0.4, 0.4, 0.6, 0.4 );
			parent.cache.rectEdgesBottom = parent.base.rect( 0.4, 0.6, 0.6, 0.6 );
			parent.cache.rectEdgesFilled = parent.base.rect( 0.4, 0.4, 0.6, 0.6 ).fill( 0.5, 0.5 );

			this.script.rectEdgesLeft = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectEdgesLeft
						.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectEdgesRight = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectEdgesRight
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectEdgesTop = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectEdgesTop
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectEdgesBottom = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectEdgesBottom
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectEdgesFilled = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectEdgesFilled
					.each( parent.fx.scale, { value: 1-age }, time );
			}



	// Strings filled screen --------------------------------------------------------------------------------
			parent.cache.rectScreenLeft = parent.base.rect( 0, 0, 0.3, 1 ).fill( 0.2, 0.5 );
			parent.cache.rectScreenRight = parent.base.rect( 0.7, 0, 1, 1 ).fill( 0.8, 0.5 );
			parent.cache.rectScreenCenter = parent.base.rect( 0.3, 0, 0.7, 1 ).fill( 0.5, 0.5 );
			
			//parent.cache.rectStripes3 = parent.base.rect( 0.1, 0.1, 0.9, 0.9 ).fill( 0.5, 0.5 );
			
			parent.cache.rectScreenStripes2 = parent.base
				.rect( 0.23, 0.1, 0.43, 0.9 ).fill( 0.35, 0.5 )
				.rect( 0.58, 0.1, 0.77, 0.9 ).fill( 0.65, 0.5 );
			parent.cache.rectScreenStripes3 = parent.base
				.rect( 0.1, 0.1, 0.2, 0.9 ).fill( 0.15, 0.5 )
				.rect( 0.45, 0.1, 0.55, 0.9 ).fill( 0.5, 0.5 )
				.rect( 0.8, 0.1, 0.9, 0.9 ).fill( 0.85, 0.5 );
			parent.cache.rectScreenBar01 = parent.base.rect( 0.1, 0.23, 0.9, 0.4 ).fill( 0.5, 0.35 );
			parent.cache.rectScreenBar02 = parent.base.rect( 0.1, 0.4, 0.9, 0.5 ).fill( 0.5, 0.45 );
			parent.cache.rectScreenBar03 = parent.base.rect( 0.1, 0.5, 0.9, 0.6 ).fill( 0.5, 0.55 );
			parent.cache.rectScreenBar04 = parent.base.rect( 0.1, 0.6, 0.9, 0.77 ).fill( 0.5, 0.65 );

			this.script.rectScreenLeft = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenLeft
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectScreenRight = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenRight
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectScreenCenter = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenCenter
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.rectScreenStripes2 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenStripes2
					.each( parent.fx.scale, { value: 2-age*2 }, time );
			}
			
			this.script.rectScreenStripes3 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenStripes3
					.each( parent.fx.scale, { value: 2-age*2 }, time );
			}
			
			
			this.script.rectScreenBar01 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenBar01
					.each( parent.fx.scale, { value: 2-age*2 }, time );
			}
			
			this.script.rectScreenBar02 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenBar02
					.each( parent.fx.scale, { value: 2-age*2 }, time );
			}
			
			this.script.rectScreenBar03 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenBar03
					.each( parent.fx.scale, { value: 2-age*2 }, time );
			}
			
			this.script.rectScreenBar04 = function( parent:Field, time:Number, age:Number ) {
				parent.cache.rectScreenBar04
					.each( parent.fx.scale, { value: 2-age*2 }, time );
			}



	// Vocals Ouch ------------------------------------------------------------------------------------------
			parent.cache.vocalOuch = parent.base
				.rect( 0.3, 0, 0.3, 0.3 ).rect( 0.4, 0, 0.4, 0.3 ).rect( 0.5, 0, 0.5, 0.3 ).rect( 0.6, 0, 0.6, 0.3 ).rect( 0.7, 0, 0.7, 0.3 )
				.rect( 0.3, 0.7, 0.3, 1 ).rect( 0.4, 0.7, 0.4, 1 ).rect( 0.5, 0.7, 0.5, 1 ).rect( 0.6, 0.7, 0.6, 1 ).rect( 0.7, 0.7, 0.7, 1 );

			parent.cache.vocalOuchNegative = parent.base
				.rect( 0.05, 0.1, 0.08, 0.9 )
				.rect( 0.92, 0.1, 0.95, 0.9 );
			
			parent.cache.vocalOuchXHorz = parent.base
				.rect( 0, 0.3, 1, 0.7 )
				.fill( 0.5, 0.5 );
			
			parent.cache.vocalOuchXVert = parent.base
				.rect( 0.35, 0, 0.75, 1 )
				.fill( 0.5, 0.5 );

			this.script.vocalOuch = function( parent:Field, time:Number, age:Number ) {
				parent.cache.vocalOuch
					.each( parent.fx.scale, { value: (1-age)*2 }, time )
					.each( parent.fx.color, { r:230, g:255, b:129, intensity:(1-age) }, time );
			}

			this.script.vocalOuchFilled = function( parent:Field, time:Number, age:Number ) {
				parent.cache.all
					.each( parent.fx.color, { r:230, g:255, b:129, intensity:(1-age) }, time );
			}

			this.script.vocalOuchNegative = function( parent:Field, time:Number, age:Number ) {
				parent.cache.vocalOuchNegative
					.each( parent.fx.scale, { value: 2-age*2 }, time )
					.each( parent.fx.color, { r:230, g:255, b:129, intensity:(1-age) }, time );
			}
			
			this.script.vocalOuchXHorz = function( parent:Field, time:Number, age:Number ) {
				parent.cache.vocalOuchXHorz
					.each( parent.fx.plasma, {}, time/100 )
					.each( parent.fx.scale, { factor: 2-age*2 }, time )
					.each( parent.fx.color, { r:230, g:255, b:129, intensity:(1-age) }, time );
			}
			
			this.script.vocalOuchXVert = function( parent:Field, time:Number, age:Number ) {
				parent.cache.vocalOuchXVert
					.each( parent.fx.plasma, {}, time/100 )
					.each( parent.fx.scale, { factor: 2-age*2 }, time )
					.each( parent.fx.color, { r:230, g:255, b:129, intensity:(1-age) }, time );
			}



	// Base Drum --------------------------------------------------------------------------------------------
			parent.cache.basDrumCenterRect = parent.base.rect( 0, 0.34, 1, 0.65 );
			parent.cache.baseDrumCenterCircle = parent.base.circle( 0.5, 0.5, 0.25 ).circle( 0.5, 0.5, 0.33 ).fill( 0.5, 0.8 );

			this.script.baseDrumCenterRect = function( parent:Field, time:Number, age:Number ) {
				parent.scaleX = parent.scaleY = 1 + (1-age)/7;
				parent.cache.basDrumCenterRect
					.each( parent.fx.scale, { value: 1-age }, time );
			}

			this.script.baseDrumCenterCircle = function( parent:Field, time:Number, age:Number ) {
				parent.cache.baseDrumCenterCircle
					.each( parent.fx.scale, { value: 1-age }, time );
					
				if( time < 130550 ) {
					// turn ccw 
					var rotationAge:Number = (time-96865)/(130550-96865);
					parent.rotation = rotationAge * 360 - 10 + (1-(Math.pow(1-age,3))) * 10;
					parent.scaleX = parent.scaleY = 1 - (1-age)/5;
				} else {
					parent.scaleX = parent.scaleY = 1;
				}
			}

			this.script.baseDrumZoom = function( parent:Field, time:Number, age:Number ) {
				parent.scaleX = parent.scaleY = 1 - (1-age)/10;
			}



	// Programmed Hihats ------------------------------------------------------------------------------------
			parent.cache.hihats01 = parent.base
				.rect( 0.1, 0.8, 0.2, 0.9 ).fill( 0.15, 0.85 )
				.rect( 0.8, 0.8, 0.9, 0.9 ).fill( 0.85, 0.85 )
				.rect( 0.1, 0.1, 0.2, 0.2 ).fill( 0.15, 0.15 )
				.rect( 0.8, 0.1, 0.9, 0.2 ).fill( 0.85, 0.15 )
				.glow( 0.1 );

			parent.cache.hihats02 = parent.base
				.rect( 0.18, 0.42, 0.18, 0.58 )
				.rect( 0.82, 0.42, 0.82, 0.58 )
				.rect( 0.45, 0.05, 0.55, 0.05 )
				.rect( 0.45, 0.95, 0.55, 0.95 );

			parent.cache.hihats03 = parent.base
				.rect( 0.1, 0.8, 0.2, 0.9 ).fill( 0.15, 0.85 )
				.rect( 0.8, 0.8, 0.9, 0.9 ).fill( 0.85, 0.85 )
				.rect( 0.1, 0.1, 0.2, 0.2 ).fill( 0.15, 0.15 )
				.rect( 0.8, 0.1, 0.9, 0.2 ).fill( 0.85, 0.15 );


			this.script.hihats01 = function( parent:Field, time:Number, age:Number ) {
				var scale:Number = parent.soundSpectrum[2] > 0.02 ? parent.soundSpectrum[2]*8 : 0;
				parent.cache.hihats01
					.each( parent.fx.plasma, {}, time/100 )
					.each( parent.fx.scale, { factor: scale*2 }, time );
			}

			this.script.hihats02 = function( parent:Field, time:Number, age:Number ) {
				var scale:Number = parent.soundSpectrum[2] > 0.02 ? parent.soundSpectrum[2]*4 : 0;
				parent.cache.hihats02
					.each( parent.fx.scale, { value: scale }, time );
			}

			this.script.hihats03 = function( parent:Field, time:Number, age:Number ) {
				var scale:Number = parent.soundSpectrum[2] > 0.02 ? parent.soundSpectrum[2]*4 : 0;
				parent.cache.hihats03
					.each( parent.fx.scale, { value: scale }, time );
			}



	// Sirene & Knartsch ------------------------------------------------------------------------------------
			
			this.script.sireneFadeout = function( parent:Field, time:Number, age:Number ) {
				parent.cache.all
					.each( parent.fx.color, { r: 255, g:90, b:0, intensity: (1-age)*( 1-Math.abs(Math.cos(time))/4 ) }, time );
			}
			
			this.script.sireneFadeoutLight = function( parent:Field, time:Number, age:Number ) {
				parent.cache.all
					.each( parent.fx.color, { r: 255, g:220, b:150, intensity: (1-age)*( 1-Math.abs(Math.cos(time))/4 ) }, time );
			}
			
			parent.cache.stripes = parent.base
				.rect( 0.1, 0, 0.1, 1 ).rect( 0.2, 0, 0.2, 1 ).rect( 0.3, 0, 0.3, 1 ).rect( 0.4, 0, 0.4, 1 ).rect( 0.5, 0, 0.5, 1 )
				.rect( 0.6, 0, 0.6, 1 ).rect( 0.7, 0, 0.7, 1 ).rect( 0.8, 0, 0.8, 1 ).rect( 0.9, 0, 0.9, 1 )
				.glow( 1 );
			this.script.screenFlutter = function( parent:Field, time:Number, age:Number ) {
				var f:Number = (1-age)*( 1-Math.abs(Math.cos(time/10)) );
				parent.cache.all
					.each( parent.fx.color, { r: 255, g:0, b:255, intensity: f }, time );
				parent.cache.stripes
					.each( parent.fx.scale, { value: f }, time );
			}
			
			
			
			
			
// Sequence definition //////////////////////////////////////////////////////////////////////////////////////
			this.queue = [

	// Global transitions -----------------------------------------------------------------------------------
				// start zoom out (starts early 0_o)
				{ start: -10000, end: 48715, func:function( parent:Field, time:Number, age:Number ) {
						parent.scaleX = parent.scaleY = (10 - Math.pow(age*3,2));
					}
				},
				
				// end zoom in
				{ start: 185220, end: 190220, func:function( parent:Field, time:Number, age:Number ) {
						parent.scaleX = parent.scaleY = (1 + Math.pow(age*3,2));
						parent.rotation = Math.pow(age,4) * 360;
					}
				},
				
				
				// woohooo, everything's spinnig!!11
				{ start: 96865, end: 130550, z: 1, func:function( parent:Field, time:Number, age:Number ) {
						parent.rotation = age * 360;
					}
				},
				

	// Programmed Hihats ------------------------------------------------------------------------------------
				{ start: 0, end: 94550, func: this.script.hihats01 },
				{ start: 94550, end: 142610, func: this.script.hihats02, z: 105 },
				{ start: 154690, end: 190000, func: this.script.hihats03 },
				

	// Vocals "Oouch" ---------------------------------------------------------------------------------------
				{ start: 50540, end: 51040, func: this.script.vocalOuch },
				{ start: 55430, end: 55930, func: this.script.vocalOuch },
				{ start: 57730, end: 58230, func: this.script.vocalOuch },
				{ start: 60300, end: 60800, func: this.script.vocalOuch },
				{ start: 65180, end: 65680, func: this.script.vocalOuch },
				{ start: 72100, end: 72600, func: this.script.vocalOuch },
				{ start: 72510, end: 73010, func: this.script.vocalOuch },
				{ start: 77000, end: 77500, func: this.script.vocalOuch },
				{ start: 77340, end: 77840, func: this.script.vocalOuch },
				{ start: 81600, end: 82100, func: this.script.vocalOuch },
				{ start: 81740, end: 82240, func: this.script.vocalOuch },
				{ start: 82250, end: 82750, func: this.script.vocalOuch },
				{ start: 101460, end: 101960, func: this.script.vocalOuchFilled },
				{ start: 105460, end: 105960, func: this.script.vocalOuchFilled },
				{ start: 105730, end: 106230, func: this.script.vocalOuchFilled },
				{ start: 106360, end: 106860, func: this.script.vocalOuchFilled },
				{ start: 110520, end: 111020, func: this.script.vocalOuchFilled },
				{ start: 110680, end: 111180, func: this.script.vocalOuchFilled },
				{ start: 111220, end: 111720, func: this.script.vocalOuchFilled },
				{ start: 120330, end: 120830, func: this.script.vocalOuchFilled },
				{ start: 120700, end: 121200, func: this.script.vocalOuchFilled },
				{ start: 125190, end: 125690, func: this.script.vocalOuchFilled },
				{ start: 125560, end: 126060, func: this.script.vocalOuchFilled },
				{ start: 128120, end: 128620, func: this.script.vocalOuchFilled },
				{ start: 128650, end: 129150, func: this.script.vocalOuchFilled },
				{ start: 129020, end: 129520, func: this.script.vocalOuchFilled },
				{ start: 129530, end: 130030, func: this.script.vocalOuchFilled },
				{ start: 130040, end: 130540, func: this.script.vocalOuchFilled },
				{ start: 130430, end: 130930, func: this.script.vocalOuchFilled },
				{ start: 133650, end: 134150, func: this.script.vocalOuchFilled },
				{ start: 134270, end: 134770, func: this.script.vocalOuchFilled },
				{ start: 134680, end: 135180, func: this.script.vocalOuchFilled },

				{ start: 135060, end: 135560, func: this.script.vocalOuchFilled }, // buzz
				{ start: 135130, end: 135630, func: this.script.vocalOuchFilled },
				{ start: 135180, end: 135680, func: this.script.vocalOuchFilled },
				{ start: 135240, end: 135740, func: this.script.vocalOuchFilled },
				{ start: 135300, end: 135800, func: this.script.vocalOuchFilled },
				{ start: 135360, end: 135860, func: this.script.vocalOuchFilled },

				{ start: 142380, end: 142880, func: this.script.vocalOuchXHorz },
				{ start: 142510, end: 143010, func: this.script.vocalOuchXVert },

				{ start: 161600, end: 162100, func: this.script.vocalOuchNegative },
				{ start: 161720, end: 162220, func: this.script.vocalOuchNegative },
				{ start: 166620, end: 167120, func: this.script.vocalOuchNegative },
				{ start: 168110, end: 168610, func: this.script.vocalOuchNegative },
				{ start: 168510, end: 169010, func: this.script.vocalOuchNegative },
				{ start: 169150, end: 169650, func: this.script.vocalOuchNegative },
				{ start: 171490, end: 171990, func: this.script.vocalOuchNegative },
				{ start: 173000, end: 173500, func: this.script.vocalOuchNegative },
				{ start: 174020, end: 174520, func: this.script.vocalOuchNegative },
				{ start: 176330, end: 176830, func: this.script.vocalOuchNegative },
				{ start: 177640, end: 178140, func: this.script.vocalOuchNegative },
				{ start: 178660, end: 179160, func: this.script.vocalOuchNegative },
				{ start: 181210, end: 181710, func: this.script.vocalOuchNegative },
				{ start: 181440, end: 181940, func: this.script.vocalOuchNegative },
				{ start: 181720, end: 182220, func: this.script.vocalOuchNegative },
				{ start: 182090, end: 182590, func: this.script.vocalOuchNegative },
				{ start: 182490, end: 182990, func: this.script.vocalOuchNegative },
				{ start: 182630, end: 183130, func: this.script.vocalOuchNegative },
				{ start: 183530, end: 184030, func: this.script.vocalOuchNegative },
				{ start: 183680, end: 184180, func: this.script.vocalOuchNegative },


	// Vocals "Bleble" --------------------------------------------------------------------------------------
				{ start: 71600, end: 72100, func: this.script.circleCenterSmall, z:300 },
				{ start: 81150, end: 81650, func: this.script.circleCenterSmall, z:300 },
				{ start: 89150, end: 89650, func: this.script.circleCenterSmall, z:300 },

				{ start: 107110, end: 107610, func: this.script.circleCenterSmall, z:300 }, // half
				{ start: 110310, end: 110810, func: this.script.circleCenterSmall, z:300 }, // half

				{ start: 137240, end: 137740, func: this.script.circleCenterSmall, z:300 },
				{ start: 156600, end: 157100, func: this.script.circleCenterSmall, z:300 },


	// Knartsch ---------------------------------------------------------------------------------------------
				{ start: 119120, end: 119440, func: this.script.screenFlutter, z:20 }, // begin
				{ start: 119240, end: 119940, func: this.script.screenFlutter, z:20 }, // begin
				//{ start: 119440, end: 119940, func: this.script.screenflutter }, // end


	// Vocals Sirene ----------------------------------------------------------------------------------------
				{ start: 63150, end: 65580, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 92130, end: 94430, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 145170, end: 148280, func: this.script.sireneFadeout, z:10 },
				{ start: 150040, end: 153000, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 154690, end: 157520, func: this.script.sireneFadeout, z:10 },
				{ start: 159520, end: 162090, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 164400, end: 166700, func: this.script.sireneFadeout, z:10 },
				{ start: 166700, end: 169310, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 169310, end: 171600, func: this.script.sireneFadeout, z:10 },
				{ start: 171600, end: 174150, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 174150, end: 176470, func: this.script.sireneFadeout, z:10 },
				{ start: 176470, end: 179050, func: this.script.sireneFadeoutLight, z:10 },
				{ start: 179050, end: 181340, func: this.script.sireneFadeout, z:10 },
				{ start: 181340, end: 183690, func: this.script.sireneFadeout, z:10 },
				{ start: 183690, end: 190140, func: this.script.sireneFadeout, z:10 },

				
	// Stringed Instruments ---------------------------------------------------------------------------------
				{ start: 330, end: 1180, func: this.script.rowCenterShort },
				{ start: 780, end: 1650, func: this.script.rowCenterShort },
				{ start: 1050, end: 2180, func: this.script.rowCenterShort },
				{ start: 1680, end: 5810, func: this.script.rowCenterShort },
				{ start: 5310, end: 6030, func: this.script.circleCenterSmall },
				{ start: 5530, end: 6240, func: this.script.circleCenterSmall },
				{ start: 5740, end: 6930, func: this.script.circleCenterSmall },
				{ start: 6430, end: 8720, func: this.script.circleCenterSmall },
				{ start: 8220, end: 10580, func: this.script.pointCenter },

				{ start: 10080, end: 11240, func: this.script.rectCenterSmall },
				{ start: 10740, end: 11880, func: this.script.rectCenterSmall },
				{ start: 11380, end: 12110, func: this.script.rectCenterSmall },
				{ start: 11610, end: 13590, func: this.script.rectCenterSmall },

				{ start: 13090, end: 15200, func: this.script.rowCenterShort },
				{ start: 14700, end: 18200, func: this.script.circleCenterSmall },
				{ start: 17900, end: 20040, func: this.script.squareCenterSmall },

				{ start: 19540, end: 20610, func: this.script.columnLeftShort },
				{ start: 20110, end: 20790, func: this.script.columnCenterShort },
				{ start: 20290, end: 21560, func: this.script.columnLeftShort },
				{ start: 21060, end: 21860, func: this.script.columnCenterShort },
				{ start: 21360, end: 22970, func: this.script.columnRightShort },

				{ start: 22470, end: 24920, func: this.script.circleCenterSmall },
				{ start: 24420, end: 27880, func: this.script.squareCenterSmall },
				{ start: 27380, end: 28500, func: this.script.squareCenterSmall },

				{ start: 28000, end: 28750, func: this.script.columnLeftShort },
				{ start: 28250, end: 29010, func: this.script.columnLeftShort },
				{ start: 28510, end: 29170, func: this.script.columnLeftShort },

				{ start: 28670, end: 29570, func: this.script.columnRightShort },
				{ start: 29070, end: 29690, func: this.script.columnRightShort },

				{ start: 29190, end: 29810, func: this.script.circleCenterSmall },
				{ start: 29310, end: 30050, func: this.script.circleCenterSmall },
				{ start: 29550, end: 31970, func: this.script.pointCenter },

				{ start: 31470, end: 32090, func: this.script.circleCenterSmall },
				{ start: 31590, end: 32600, func: this.script.circleCenterSmall },
				{ start: 31900, end: 34640, func: this.script.pointCenter },

				{ start: 34140, end: 34770, func: this.script.circleCenterSmall },
				{ start: 34270, end: 36960, func: this.script.pointCenter },


				{ start: 36460, end: 37720, func: this.script.circleCenterSmall },
				{ start: 37220, end: 38500, func: this.script.circleCenterSmall },
				{ start: 38000, end: 38960, func: this.script.circleCenterSmall },
				{ start: 38460, end: 39150, func: this.script.circleCenterSmall },

				{ start: 38650, end: 39520, func: this.script.circleCenterSmall },
				{ start: 39020, end: 39800, func: this.script.pointCenter },

				{ start: 39300, end: 41720, func: this.script.circleCenterSmall },
				{ start: 41220, end: 41830, func: this.script.pointCenter },

				{ start: 41330, end: 42060, func: this.script.pointCenter },
				{ start: 41560, end: 44130, func: this.script.circleCenterSmall },

				{ start: 43630, end: 44240, func: this.script.circleCenterMedium },
				{ start: 43740, end: 46710, func: this.script.circleCenterMediumFilled },
				{ start: 46210, end: 47500, func: this.script.circleCenterMediumFilled },
				{ start: 47000, end: 47950, func: this.script.circleCenterMediumFilled },

				{ start: 47450, end: 48710, func: this.script.circleCenterSmall },
				{ start: 48210, end: 49020, func: this.script.circleCenterMediumFilled },

				{ start: 48520, end: 49520, func: this.script.rectCenterPlasmaCondensed },
				{ start: 49020, end: 51570, func: this.script.rectCenterPlasma },
				{ start: 51070, end: 51850, func: this.script.rectCenterPlasmaCondensed },
				{ start: 51350, end: 53840, func: this.script.rectCenterPlasma },
				{ start: 53340, end: 54130, func: this.script.rectCenterPlasmaCondensed },
				{ start: 53630, end: 56190, func: this.script.rectCenterPlasma },

				{ start: 55690, end: 56980, func: this.script.rectCenterPlasma },
				{ start: 56480, end: 57730, func: this.script.rectCenterPlasma },
				{ start: 57230, end: 58500, func: this.script.rectCenterPlasma },
				{ start: 58000, end: 58770, func: this.script.rectCenterPlasma },

				{ start: 58270, end: 59010, func: this.script.rectCenterPlasmaCondensed },
				{ start: 58510, end: 61090, func: this.script.rectCenterPlasma },
				{ start: 60590, end: 61580, func: this.script.rectCenterPlasmaCondensed },
				{ start: 61080, end: 63570, func: this.script.rectCenterPlasma },
				{ start: 63070, end: 63890, func: this.script.rectCenterPlasmaCondensed },
				{ start: 63390, end: 65940, func: this.script.rectCenterPlasma },
				{ start: 65440, end: 66690, func: this.script.rectCenterPlasmaCondensed },
				{ start: 66190, end: 67200, func: this.script.rectCenterPlasma },
				{ start: 66700, end: 67570, func: this.script.rectCenterPlasmaCondensed },
				{ start: 67070, end: 68520, func: this.script.rectCenterPlasma },

				{ start: 67920, end: 68993, func: this.script.stringSequence01 },
				{ start: 68622, end: 69643, func: this.script.stringSequence02 },
				{ start: 68993, end: 69969, func: this.script.stringSequence03 },
				{ start: 69643, end: 70560, func: this.script.stringSequence04 },
				{ start: 69969, end: 70665, func: this.script.stringSequence05 },
				{ start: 70560, end: 71037, func: this.script.stringSequence05 },
				{ start: 70665, end: 71687, func: this.script.stringSequence04 },
				{ start: 71037, end: 71987, func: this.script.stringSequence03 },
				{ start: 71687, end: 72280, func: this.script.stringSequence02 },
				{ start: 71987, end: 72480, func: this.script.stringSequence01 },

				{ start: 72458, end: 73850, func: this.script.stringSequence05 },
				{ start: 72801, end: 74120, func: this.script.stringSequence04 },
				{ start: 73498, end: 74870, func: this.script.stringSequence03 },
				{ start: 73823, end: 75160, func: this.script.stringSequence02 },
				{ start: 74520, end: 75900, func: this.script.stringSequence01 },
				{ start: 74845, end: 75400, func: this.script.stringSequence01 },
				{ start: 75400, end: 76190, func: this.script.stringSequence02 },
				{ start: 75690, end: 76950, func: this.script.stringSequence03 },
				{ start: 76450, end: 77160, func: this.script.stringSequence04 },
				{ start: 76660, end: 77970, func: this.script.stringSequence05 },

				{ start: 77470, end: 78750, func: this.script.stringSequence01 },
				{ start: 78250, end: 78960, func: this.script.stringSequence02 },
				{ start: 78460, end: 79760, func: this.script.stringSequence03 },
				{ start: 79260, end: 80010, func: this.script.stringSequence04 },
				{ start: 79510, end: 80750, func: this.script.stringSequence05 },
				{ start: 80250, end: 81040, func: this.script.stringSequence04 },
				{ start: 80540, end: 81810, func: this.script.stringSequence03 },
				{ start: 81310, end: 82070, func: this.script.stringSequence02 },
				{ start: 81570, end: 82940, func: this.script.stringSequence01 },

				{ start: 82440, end: 83610, func: this.script.stringSequence03 },
				{ start: 83110, end: 83840, func: this.script.stringSequence01 },
				{ start: 83340, end: 84590, func: this.script.stringSequence05 },
				{ start: 84090, end: 84890, func: this.script.stringSequence02 },
				{ start: 84390, end: 85640, func: this.script.stringSequence04 },
				{ start: 85140, end: 85900, func: this.script.stringSequence05 },
				{ start: 85400, end: 86560, func: this.script.stringSequence01 },

				{ start: 86060, end: 86690, func: this.script.stringSequence02 },
				{ start: 86190, end: 86890, func: this.script.stringSequence03 },
				{ start: 86390, end: 87760, func: this.script.stringSequence04 },

				{ start: 87260, end: 90050, func: this.script.stringSequence01 },
				{ start: 87260, end: 90050, func: this.script.stringSequence03 },
				{ start: 87260, end: 90050, func: this.script.stringSequence05 },

				{ start: 89650, end: 92550, func: this.script.stringSequence02 },
				{ start: 89650, end: 92550, func: this.script.stringSequence04 },

				{ start: 92050, end: 92810, func: this.script.rectCenterPlasmaCondensed },
				{ start: 92310, end: 94870, func: this.script.rectCenterPlasma },
				
				{ start: 94497, end: 95180, func: this.script.rectLeftToRight, z:110 },
				{ start: 95101, end: 95760, func: this.script.rectRightToLeft, z:111 },
				{ start: 95751, end: 96300, func: this.script.rectLeftToRight, z:112 },
				{ start: 96076, end: 96940, func: this.script.rectRightToLeft, z:113 },


				{ start: 96865, end: 97980, func: this.script.circleCenterExpand },
				{ start: 97469, end: 98500, func: this.script.circleCenterExpand },
				{ start: 97794, end: 98960, func: this.script.circleCenterExpand },
				{ start: 98537, end: 99200, func: this.script.circleCenterHollow },
				{ start: 98909, end: 100000, func: this.script.circleCenterHollow },
				{ start: 99513, end: 100510, func: this.script.circleCenterExpand },
				{ start: 99838, end: 101000, func: this.script.circleCenterExpand },
				{ start: 100581, end: 101540, func: this.script.circleCenterContract },
				{ start: 101000, end: 102100, func: this.script.circleCenterContract },

				{ start: 101600, end: 102850, func: this.script.circleCenterExpand },
				{ start: 102350, end: 103080, func: this.script.circleCenterExpand },
				{ start: 102580, end: 103850, func: this.script.circleCenterExpand },
				{ start: 103350, end: 104170, func: this.script.circleCenterHollow },
				{ start: 103670, end: 104970, func: this.script.circleCenterHollow },
				{ start: 104470, end: 105220, func: this.script.circleCenterExpand },
				{ start: 104720, end: 105910, func: this.script.circleCenterExpand },
				{ start: 105410, end: 106190, func: this.script.circleCenterContract },
				{ start: 105690, end: 106950, func: this.script.circleCenterContract },

				{ start: 106450, end: 107660, func: this.script.circleCenterExpand },
				{ start: 107160, end: 107920, func: this.script.circleCenterExpand },
				{ start: 107420, end: 108730, func: this.script.circleCenterExpand },
				{ start: 108230, end: 108980, func: this.script.circleCenterHollow },
				{ start: 108480, end: 109740, func: this.script.circleCenterHollow },
				{ start: 109240, end: 110010, func: this.script.circleCenterExpand },
				{ start: 109510, end: 110780, func: this.script.circleCenterExpand },
				{ start: 110280, end: 111100, func: this.script.circleCenterContract },
				{ start: 110600, end: 111880, func: this.script.circleCenterContract },

				{ start: 111380, end: 112550, func: this.script.circleCenterExpand },
				{ start: 112050, end: 112840, func: this.script.circleCenterExpand },
				{ start: 112340, end: 113610, func: this.script.circleCenterExpand },
				{ start: 113110, end: 113910, func: this.script.circleCenterHollow },
				{ start: 113410, end: 114650, func: this.script.circleCenterHollow },
				{ start: 114150, end: 114910, func: this.script.circleCenterExpand },
				{ start: 114410, end: 115700, func: this.script.circleCenterExpand },
				{ start: 115200, end: 115950, func: this.script.circleCenterContract },
				{ start: 115450, end: 116730, func: this.script.circleCenterContract },


				{ start: 116230, end: 117210, func: this.script.circleCenterExpand },
				{ start: 116710, end: 117720, func: this.script.circleCenterExpand },
				{ start: 117220, end: 118230, func: this.script.circleCenterExpand },
				{ start: 117730, end: 118710, func: this.script.circleCenterHollow },
				{ start: 118210, end: 119230, func: this.script.circleCenterHollow },
				{ start: 118730, end: 119770, func: this.script.circleCenterExpand },
				{ start: 119270, end: 120660, func: this.script.circleCenterExpand },
				{ start: 120160, end: 120880, func: this.script.circleCenterContract },
				{ start: 120380, end: 121620, func: this.script.circleCenterContract },


				{ start: 121120, end: 122100, func: this.script.circleCenterExpand },
				{ start: 121600, end: 122610, func: this.script.circleCenterExpand },
				{ start: 122110, end: 123090, func: this.script.circleCenterExpand },
				{ start: 122590, end: 123600, func: this.script.circleCenterHollow },
				{ start: 123100, end: 124120, func: this.script.circleCenterHollow },
				{ start: 123620, end: 124630, func: this.script.circleCenterExpand },
				{ start: 124130, end: 125190, func: this.script.circleCenterExpand },
				{ start: 124690, end: 125180, func: this.script.circleCenterContract },
				{ start: 124960, end: 126580, func: this.script.circleCenterContract },



				{ start: 125680, end: 126960, func: this.script.circleCenterExpand },
				{ start: 126460, end: 127220, func: this.script.circleCenterExpand },
				{ start: 126720, end: 127960, func: this.script.circleCenterExpand },
				{ start: 127460, end: 128230, func: this.script.circleCenterHollow },
				{ start: 127730, end: 129010, func: this.script.circleCenterHollow },
				{ start: 128510, end: 129590, func: this.script.circleCenterExpand },
				{ start: 129090, end: 130010, func: this.script.circleCenterExpand },
				{ start: 129510, end: 130520, func: this.script.circleCenterContract },
				{ start: 130020, end: 131050, func: this.script.circleCenterContract },


				{ start: 130550, end: 131760, func: this.script.rectEdgesLeft },
				{ start: 131260, end: 132090, func: this.script.rectEdgesRight },
				{ start: 131590, end: 132860, func: this.script.rectEdgesTop },
				{ start: 132360, end: 133080, func: this.script.rectEdgesLeft },
				{ start: 132580, end: 133870, func: this.script.rectEdgesRight },
				{ start: 133370, end: 135540, func: this.script.rectEdgesBottom },
				{ start: 133640, end: 136030, func: this.script.rectEdgesTop },

				{ start: 135530, end: 138510, func: this.script.rectEdgesFilled },
				{ start: 138010, end: 140810, func: this.script.rectEdgesFilled },
				{ start: 140310, end: 143110, func: this.script.rectEdgesFilled },

				{ start: 142610, end: 143900, func: this.script.rectScreenLeft, z: 110 },
				{ start: 143400, end: 144650, func: this.script.rectScreenRight, z: 111  },
				{ start: 144150, end: 145120, func: this.script.rectScreenCenter, z: 112  },
				{ start: 144620, end: 145680, func: this.script.rectScreenLeft, z: 113  },
				{ start: 145180, end: 145950, func: this.script.rectScreenCenter, z: 114  },

				{ start: 145450, end: 147990, func: this.script.rectScreenLeft, z: 115  },
				{ start: 145450, end: 147990, func: this.script.rectScreenRight, z: 116 },

				{ start: 147490, end: 148520, func: this.script.rectScreenCenter, z: 117 },
				{ start: 148020, end: 150560, func: this.script.rectScreenLeft, z: 118 },
				{ start: 148020, end: 150560, func: this.script.rectScreenRight, z: 119 },

				{ start: 150060, end: 150820, func: this.script.rectScreenLeft, z: 120 },
				{ start: 150060, end: 150820, func: this.script.rectScreenRight, z: 121 },
				{ start: 150320, end: 152850, func: this.script.rectScreenCenter, z: 122 },

				{ start: 152350, end: 153130, func: this.script.rectScreenLeft, z: 123 },
				{ start: 152350, end: 153130, func: this.script.rectScreenRight, z: 124 },
				{ start: 152630, end: 154690, func: this.script.rectScreenCenter, z: 125 },
		
				

				{ start: 154690, end: 155247, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 155047, end: 157790, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 157290, end: 157662, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 157462, end: 160010, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 159510, end: 160031, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 159831, end: 162590, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 162090, end: 163120, func: this.script.rectScreenBar01, z: 10 },
				{ start: 162620, end: 163850, func: this.script.rectScreenBar02, z: 10 },
				{ start: 163350, end: 164140, func: this.script.rectScreenBar03, z: 10 },
				{ start: 163640, end: 164870, func: this.script.rectScreenBar04, z: 10 },
				
				{ start: 164270, end: 165050, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 164550, end: 167220, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 166820, end: 167275, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 167175, end: 170010, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 169210, end: 169876, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 169576, end: 172110, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 171610, end: 172840, func: this.script.rectScreenBar01, z: 10 },
				{ start: 172340, end: 173610, func: this.script.rectScreenBar02, z: 10 },
				{ start: 173110, end: 173850, func: this.script.rectScreenBar03, z: 10 },
				{ start: 173350, end: 174650, func: this.script.rectScreenBar04, z: 10 },
				
				{ start: 174150, end: 174900, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 174400, end: 176980, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 176480, end: 177240, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 176840, end: 179550, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 179050, end: 179740, func: this.script.rectScreenStripes3, z: 10 },
				{ start: 179290, end: 181830, func: this.script.rectScreenStripes2, z: 10 },
				{ start: 181330, end: 182560, func: this.script.rectScreenBar01, z: 10 },
				{ start: 182060, end: 183080, func: this.script.rectScreenBar02, z: 10 },
				{ start: 182580, end: 183610, func: this.script.rectScreenBar03, z: 10 },
				{ start: 183110, end: 184500, func: this.script.rectScreenBar04, z: 10 },
				
				{ start: 184000, end: 185720, func: this.script.rowCenterShort, z: 10 },
				{ start: 184220, end: 190220, func: this.script.circleCenterSmall, z: 10 },



	// Base drum --------------------------------------------------------------------------------------------
				{ start: 48597, end: 48897, func: this.script.baseDrumCenterRect },
				{ start: 49479, end: 49779, func: this.script.baseDrumCenterRect },
				{ start: 49990, end: 50290, func: this.script.baseDrumCenterRect },
				{ start: 50501, end: 50801, func: this.script.baseDrumCenterRect },
				{ start: 51058, end: 51358, func: this.script.baseDrumCenterRect },
				{ start: 51894, end: 52194, func: this.script.baseDrumCenterRect },
				{ start: 52405, end: 52705, func: this.script.baseDrumCenterRect },
				{ start: 53427, end: 53727, func: this.script.baseDrumCenterRect },
				{ start: 54309, end: 54609, func: this.script.baseDrumCenterRect },
				{ start: 55145, end: 55445, func: this.script.baseDrumCenterRect },
				{ start: 55888, end: 56188, func: this.script.baseDrumCenterRect },
				{ start: 56120, end: 56420, func: this.script.baseDrumCenterRect },
				{ start: 56399, end: 56699, func: this.script.baseDrumCenterRect },
				{ start: 56724, end: 57024, func: this.script.baseDrumCenterRect },
				{ start: 57096, end: 57396, func: this.script.baseDrumCenterRect },
				{ start: 57281, end: 57581, func: this.script.baseDrumCenterRect },
				{ start: 57792, end: 58092, func: this.script.baseDrumCenterRect },
				{ start: 58303, end: 58603, func: this.script.baseDrumCenterRect },
				{ start: 59139, end: 59439, func: this.script.baseDrumCenterRect },
				{ start: 59650, end: 59950, func: this.script.baseDrumCenterRect },
				{ start: 60021, end: 60321, func: this.script.baseDrumCenterRect },
				{ start: 60718, end: 61018, func: this.script.baseDrumCenterRect },
				{ start: 61554, end: 61854, func: this.script.baseDrumCenterRect },
				{ start: 62065, end: 62365, func: this.script.baseDrumCenterRect },
				{ start: 62575, end: 62875, func: this.script.baseDrumCenterRect },
				{ start: 63133, end: 63433, func: this.script.baseDrumCenterRect },
				{ start: 63644, end: 63944, func: this.script.baseDrumCenterRect },
				{ start: 64665, end: 64965, func: this.script.baseDrumCenterRect },
				{ start: 64990, end: 65290, func: this.script.baseDrumCenterRect },
				{ start: 65501, end: 65801, func: this.script.baseDrumCenterRect },
				{ start: 65780, end: 66080, func: this.script.baseDrumCenterRect },
				{ start: 66058, end: 66358, func: this.script.baseDrumCenterRect },
				{ start: 66244, end: 66544, func: this.script.baseDrumCenterRect },
				{ start: 66569, end: 66869, func: this.script.baseDrumCenterRect },
				{ start: 66894, end: 67194, func: this.script.baseDrumCenterRect },
				{ start: 67823, end: 68123, func: this.script.baseDrumCenterRect },
				{ start: 69309, end: 69609, func: this.script.baseDrumCenterRect },
				{ start: 71200, end: 71500, func: this.script.baseDrumCenterRect },
				{ start: 71400, end: 71700, func: this.script.baseDrumCenterRect },
				{ start: 71910, end: 72210, func: this.script.baseDrumCenterRect },
				{ start: 72421, end: 72721, func: this.script.baseDrumCenterRect },
				{ start: 72746, end: 73046, func: this.script.baseDrumCenterRect },
				{ start: 73442, end: 73742, func: this.script.baseDrumCenterRect },
				{ start: 73628, end: 73928, func: this.script.baseDrumCenterRect },
				{ start: 74139, end: 74439, func: this.script.baseDrumCenterRect },
				{ start: 76043, end: 76343, func: this.script.baseDrumCenterRect },
				{ start: 76229, end: 76529, func: this.script.baseDrumCenterRect },
				{ start: 77436, end: 77736, func: this.script.baseDrumCenterRect },
				{ start: 78690, end: 78990, func: this.script.baseDrumCenterRect },
				{ start: 78876, end: 79176, func: this.script.baseDrumCenterRect },
				{ start: 79015, end: 79315, func: this.script.baseDrumCenterRect },
				{ start: 79340, end: 79640, func: this.script.baseDrumCenterRect },
				{ start: 79665, end: 79965, func: this.script.baseDrumCenterRect },
				{ start: 79990, end: 80290, func: this.script.baseDrumCenterRect },
				{ start: 80362, end: 80662, func: this.script.baseDrumCenterRect },
				{ start: 80687, end: 80987, func: this.script.baseDrumCenterRect },
				{ start: 80873, end: 81173, func: this.script.baseDrumCenterRect },
				{ start: 81059, end: 81359, func: this.script.baseDrumCenterRect },
				{ start: 81159, end: 81459, func: this.script.baseDrumCenterRect },
				{ start: 81200, end: 81500, func: this.script.baseDrumCenterRect },
				{ start: 81259, end: 81559, func: this.script.baseDrumCenterRect },
				{ start: 81300, end: 81659, func: this.script.baseDrumCenterRect },
				{ start: 81359, end: 81659, func: this.script.baseDrumCenterRect },
				{ start: 82080, end: 82380, func: this.script.baseDrumCenterRect },
				{ start: 82452, end: 82752, func: this.script.baseDrumCenterRect },
				{ start: 82777, end: 83077, func: this.script.baseDrumCenterRect },
				{ start: 83799, end: 84099, func: this.script.baseDrumCenterRect },
				{ start: 85145, end: 85445, func: this.script.baseDrumCenterRect },
				{ start: 85331, end: 85631, func: this.script.baseDrumCenterRect },
				{ start: 85517, end: 85817, func: this.script.baseDrumCenterRect },
				{ start: 85888, end: 86188, func: this.script.baseDrumCenterRect },
				{ start: 86213, end: 86513, func: this.script.baseDrumCenterRect },
				{ start: 86585, end: 86885, func: this.script.baseDrumCenterRect },
				{ start: 87235, end: 87535, func: this.script.baseDrumCenterRect },
				{ start: 88117, end: 88417, func: this.script.baseDrumCenterRect },
				{ start: 88628, end: 88928, func: this.script.baseDrumCenterRect },
				{ start: 89325, end: 89625, func: this.script.baseDrumCenterRect },
				{ start: 89650, end: 89950, func: this.script.baseDrumCenterRect },
				{ start: 90532, end: 90832, func: this.script.baseDrumCenterRect },
				{ start: 91043, end: 91343, func: this.script.baseDrumCenterRect },
				{ start: 92065, end: 92365, func: this.script.baseDrumCenterRect },
				{ start: 93644, end: 93944, func: this.script.baseDrumCenterRect },
				{ start: 93830, end: 94130, func: this.script.baseDrumCenterRect },
				{ start: 94155, end: 94455, func: this.script.baseDrumCenterRect },

				{ start: 96941, end: 97241, func: this.script.baseDrumCenterCircle },
				{ start: 97452, end: 97752, func: this.script.baseDrumCenterCircle },
				{ start: 99588, end: 99888, func: this.script.baseDrumCenterCircle },
				{ start: 99774, end: 100074, func: this.script.baseDrumCenterCircle },
				{ start: 99960, end: 100260, func: this.script.baseDrumCenterCircle },
				{ start: 100192, end: 100492, func: this.script.baseDrumCenterCircle },
				{ start: 100703, end: 101003, func: this.script.baseDrumCenterCircle },
				{ start: 101028, end: 101328, func: this.script.baseDrumCenterCircle },
				{ start: 101399, end: 101699, func: this.script.baseDrumCenterCircle },
				{ start: 101585, end: 101885, func: this.script.baseDrumCenterCircle },
				{ start: 101771, end: 102071, func: this.script.baseDrumCenterCircle },
				{ start: 102282, end: 102582, func: this.script.baseDrumCenterCircle },
				{ start: 102653, end: 102953, func: this.script.baseDrumCenterCircle },
				{ start: 103118, end: 103418, func: this.script.baseDrumCenterCircle },
				{ start: 103953, end: 104253, func: this.script.baseDrumCenterCircle },
				{ start: 104650, end: 104950, func: this.script.baseDrumCenterCircle },
				{ start: 105022, end: 105322, func: this.script.baseDrumCenterCircle },
				{ start: 105207, end: 105507, func: this.script.baseDrumCenterCircle },
				{ start: 105532, end: 105832, func: this.script.baseDrumCenterCircle },
				{ start: 105857, end: 106157, func: this.script.baseDrumCenterCircle },
				{ start: 106229, end: 106529, func: this.script.baseDrumCenterCircle },
				{ start: 106415, end: 106715, func: this.script.baseDrumCenterCircle },
				{ start: 106600, end: 106900, func: this.script.baseDrumCenterCircle },
				{ start: 107344, end: 107644, func: this.script.baseDrumCenterCircle },
				{ start: 107576, end: 107876, func: this.script.baseDrumCenterCircle },
				{ start: 107761, end: 108061, func: this.script.baseDrumCenterCircle },
				{ start: 107947, end: 108247, func: this.script.baseDrumCenterCircle },
				{ start: 108319, end: 108619, func: this.script.baseDrumCenterCircle },
				{ start: 108644, end: 108944, func: this.script.baseDrumCenterCircle },
				{ start: 108969, end: 109269, func: this.script.baseDrumCenterCircle },
				{ start: 109340, end: 109640, func: this.script.baseDrumCenterCircle },
				{ start: 109666, end: 109966, func: this.script.baseDrumCenterCircle },
				{ start: 109851, end: 110151, func: this.script.baseDrumCenterCircle },
				{ start: 110087, end: 110387, func: this.script.baseDrumCenterCircle },
				{ start: 110137, end: 110437, func: this.script.baseDrumCenterCircle },
				{ start: 110187, end: 110487, func: this.script.baseDrumCenterCircle },
				{ start: 110237, end: 110537, func: this.script.baseDrumCenterCircle },
				{ start: 110287, end: 110587, func: this.script.baseDrumCenterCircle },
				{ start: 111059, end: 111359, func: this.script.baseDrumCenterCircle },
				{ start: 111384, end: 111684, func: this.script.baseDrumCenterCircle },
				{ start: 111755, end: 112055, func: this.script.baseDrumCenterCircle },
				{ start: 112777, end: 113077, func: this.script.baseDrumCenterCircle },
				{ start: 114077, end: 114377, func: this.script.baseDrumCenterCircle },
				{ start: 114263, end: 114563, func: this.script.baseDrumCenterCircle },
				{ start: 114495, end: 114795, func: this.script.baseDrumCenterCircle },
				{ start: 114820, end: 115120, func: this.script.baseDrumCenterCircle },
				{ start: 115517, end: 115817, func: this.script.baseDrumCenterCircle },
				{ start: 115888, end: 116188, func: this.script.baseDrumCenterCircle },
				{ start: 116214, end: 116514, func: this.script.baseDrumCenterCircle },
				{ start: 117421, end: 117721, func: this.script.baseDrumCenterCircle },
				{ start: 117607, end: 117907, func: this.script.baseDrumCenterCircle },
				{ start: 118536, end: 118836, func: this.script.baseDrumCenterCircle },
				{ start: 118954, end: 119254, func: this.script.baseDrumCenterCircle },
				{ start: 119139, end: 119439, func: this.script.baseDrumCenterCircle },
				{ start: 119325, end: 119625, func: this.script.baseDrumCenterCircle },
				{ start: 119511, end: 119811, func: this.script.baseDrumCenterCircle },
				{ start: 119697, end: 119997, func: this.script.baseDrumCenterCircle },
				{ start: 120161, end: 120461, func: this.script.baseDrumCenterCircle },
				{ start: 120672, end: 120972, func: this.script.baseDrumCenterCircle },
				{ start: 121043, end: 121343, func: this.script.baseDrumCenterCircle },
				{ start: 121554, end: 121854, func: this.script.baseDrumCenterCircle },
				{ start: 122437, end: 122737, func: this.script.baseDrumCenterCircle },
				{ start: 122762, end: 123062, func: this.script.baseDrumCenterCircle },
				{ start: 123133, end: 123433, func: this.script.baseDrumCenterCircle },
				{ start: 123923, end: 124223, func: this.script.baseDrumCenterCircle },
				{ start: 124294, end: 124594, func: this.script.baseDrumCenterCircle },
				{ start: 124480, end: 124780, func: this.script.baseDrumCenterCircle },
				{ start: 125594, end: 125894, func: this.script.baseDrumCenterCircle },
				{ start: 125780, end: 126080, func: this.script.baseDrumCenterCircle },
				{ start: 125966, end: 126266, func: this.script.baseDrumCenterCircle },
				{ start: 126802, end: 127102, func: this.script.baseDrumCenterCircle },
				{ start: 127266, end: 127566, func: this.script.baseDrumCenterCircle },
				{ start: 127591, end: 127891, func: this.script.baseDrumCenterCircle },
				{ start: 128706, end: 129006, func: this.script.baseDrumCenterCircle },
				{ start: 128845, end: 129145, func: this.script.baseDrumCenterCircle },
				{ start: 129635, end: 129935, func: this.script.baseDrumCenterCircle },
				{ start: 130006, end: 130306, func: this.script.baseDrumCenterCircle },
				{ start: 130517, end: 130817, func: this.script.baseDrumCenterCircle },
				{ start: 130703, end: 131003, func: this.script.baseDrumCenterCircle },
				{ start: 131028, end: 131328, func: this.script.baseDrumCenterCircle },
				{ start: 131214, end: 131514, func: this.script.baseDrumCenterCircle },
				{ start: 132096, end: 132396, func: this.script.baseDrumCenterCircle },
				{ start: 133396, end: 133696, func: this.script.baseDrumCenterCircle },
				{ start: 133582, end: 133882, func: this.script.baseDrumCenterCircle },
				{ start: 133954, end: 134254, func: this.script.baseDrumCenterCircle },
				{ start: 134139, end: 134439, func: this.script.baseDrumCenterCircle },
				{ start: 135347, end: 135647, func: this.script.baseDrumCenterCircle },
				{ start: 135486, end: 135786, func: this.script.baseDrumCenterCircle },
				{ start: 136368, end: 136668, func: this.script.baseDrumCenterCircle },
				{ start: 136879, end: 137179, func: this.script.baseDrumCenterCircle },
				{ start: 137576, end: 137876, func: this.script.baseDrumCenterCircle },
				{ start: 137947, end: 138247, func: this.script.baseDrumCenterCircle },
				{ start: 138783, end: 139083, func: this.script.baseDrumCenterCircle },
				{ start: 139341, end: 139641, func: this.script.baseDrumCenterCircle },
				{ start: 140362, end: 140662, func: this.script.baseDrumCenterCircle },
				{ start: 141523, end: 141823, func: this.script.baseDrumCenterCircle },
				{ start: 141709, end: 142009, func: this.script.baseDrumCenterCircle },
				{ start: 141895, end: 142195, func: this.script.baseDrumCenterCircle },
				{ start: 142081, end: 142381, func: this.script.baseDrumCenterCircle },
				{ start: 142777, end: 143077, func: this.script.baseDrumCenterCircle },

				{ start: 154573, end: 154873, func: this.script.baseDrumZoom },
				{ start: 154805, end: 155105, func: this.script.baseDrumZoom },
				{ start: 155177, end: 155477, func: this.script.baseDrumZoom },
				{ start: 155687, end: 155987, func: this.script.baseDrumZoom },
				{ start: 156198, end: 156498, func: this.script.baseDrumZoom },
				{ start: 156895, end: 157195, func: this.script.baseDrumZoom },
				{ start: 157266, end: 157566, func: this.script.baseDrumZoom },
				{ start: 158102, end: 158402, func: this.script.baseDrumZoom },
				{ start: 158613, end: 158913, func: this.script.baseDrumZoom },
				{ start: 159635, end: 159935, func: this.script.baseDrumZoom },
				{ start: 161214, end: 161514, func: this.script.baseDrumZoom },
				{ start: 161400, end: 161700, func: this.script.baseDrumZoom },
				{ start: 162096, end: 162396, func: this.script.baseDrumZoom },
				{ start: 164372, end: 164672, func: this.script.baseDrumZoom },
				{ start: 164511, end: 164811, func: this.script.baseDrumZoom },
				{ start: 165208, end: 165508, func: this.script.baseDrumZoom },
				{ start: 165858, end: 166158, func: this.script.baseDrumZoom },
				{ start: 166554, end: 166854, func: this.script.baseDrumZoom },
				{ start: 166880, end: 167180, func: this.script.baseDrumZoom },
				{ start: 167065, end: 167365, func: this.script.baseDrumZoom },
				{ start: 168458, end: 168758, func: this.script.baseDrumZoom },
				{ start: 169294, end: 169594, func: this.script.baseDrumZoom },
				{ start: 169991, end: 170291, func: this.script.baseDrumZoom },
				{ start: 170362, end: 170662, func: this.script.baseDrumZoom },
				{ start: 170688, end: 170988, func: this.script.baseDrumZoom },
				{ start: 171059, end: 171359, func: this.script.baseDrumZoom },
				{ start: 171384, end: 171684, func: this.script.baseDrumZoom },
				{ start: 171756, end: 172056, func: this.script.baseDrumZoom },
				{ start: 171895, end: 172195, func: this.script.baseDrumZoom },
				{ start: 173288, end: 173588, func: this.script.baseDrumZoom },
				{ start: 173474, end: 173774, func: this.script.baseDrumZoom },
				{ start: 174124, end: 174424, func: this.script.baseDrumZoom },
				{ start: 175471, end: 175771, func: this.script.baseDrumZoom },
				{ start: 175703, end: 176003, func: this.script.baseDrumZoom },
				{ start: 176539, end: 176839, func: this.script.baseDrumZoom },
				{ start: 176725, end: 177025, func: this.script.baseDrumZoom },
				{ start: 178118, end: 178418, func: this.script.baseDrumZoom },
				{ start: 178304, end: 178604, func: this.script.baseDrumZoom },
				{ start: 178954, end: 179254, func: this.script.baseDrumZoom },
				{ start: 181183, end: 181483, func: this.script.baseDrumZoom },
				{ start: 182251, end: 182551, func: this.script.baseDrumZoom },
				{ start: 183820, end: 184120, func: this.script.baseDrumZoom },
			];


			// ZOMFG, mighty important! The sequence MUST be ordered chronologicaly!
			this.queue.sortOn( 'start', Array.NUMERIC );
		}
	}
}